// ResourceLoader.cpp

#include "stdafx.h"
#include "ResourceLoader.h"
#include <shlwapi.h>
#include <set>
#include <string>

namespace Resource
{
	// extends Path APIs
	static void PathTrimFileName(LPTSTR path)
	{
		*PathFindFileName(path) = _T('\0');
	}

	Loader::Loader()
	{
		m_FileDirectory[0] = _T('\0');
	}
	Loader::~Loader()
	{
		for(size_t i = 0; i < m_Dlls.size(); i++)
			FreeLibrary(m_Dlls[i]);
	}
	IO::Stream	Loader::Load(LPCTSTR name)
	{
		IO::Stream stream;
		for(std::vector<HINSTANCE>::reverse_iterator i = m_Dlls.rbegin(); i != m_Dlls.rend(); ++i)
		{
			HRESULT hr = stream.CreateOnResource(*i, name, RT_RCDATA);
			if SUCCEEDED(hr)
				return stream;
		}
		TCHAR rsc[MAX_PATH];
		lstrcpy(rsc, m_FileDirectory);
		PathAppend(rsc, name);
		stream.CreateOnFile(rsc, STGM_STANDARD_READ);
		return stream;
	}
	BOOL	Loader::SetFileDirectory(LPCTSTR path)
	{
		lstrcpy(m_FileDirectory, path);
		return TRUE;
	}
	BOOL	Loader::AddDllFile(LPCTSTR file)
	{
		HINSTANCE hDll = LoadLibrary(file);
		if(hDll == NULL)
			return FALSE;
		m_Dlls.push_back(hDll);
		return TRUE;
	}
	UINT	Loader::AddDllDirectory(LPCTSTR directory)
	{
		// FindFile()ł͗񋓂鏇Ԃŝ߁AŃt@CŃ\[g
		typedef std::basic_string<TCHAR>	String;
		typedef std::set<String>	SortedList;
		SortedList files;

		// t@C𐔂グ
		WIN32_FIND_DATA data;
		HANDLE hFindFile = FindFirstFile(directory, &data);
		BOOL found = (hFindFile != INVALID_HANDLE_VALUE);
		while(found)
		{
			TCHAR filename[MAX_PATH];
			lstrcpy(filename, directory);
			PathTrimFileName(filename);
			PathAppend(filename, data.cFileName);
			files.insert(filename);
			found = FindNextFile(hFindFile, &data);
		}
		if(hFindFile != INVALID_HANDLE_VALUE)
			FindClose(hFindFile);

		// ǉ
		UINT result = 0;
		for(SortedList::iterator i = files.begin(); i != files.end(); ++i)
		{
			if(AddDllFile(i->c_str()))
				result++;
		}
		return result;
	}
}
