/// Stream.h
#pragma once

#include <shlwapi.h>
#pragma comment(lib, "shlwapi.lib")
//#include "Debug.h"
#include <assert.h>
#define ASSERT(exp)	assert(exp)

const DWORD STGM_STANDARD_READ  = STGM_READ  | STGM_SHARE_DENY_WRITE;
const DWORD STGM_STANDARD_WRITE = STGM_WRITE | STGM_SHARE_DENY_WRITE;

/// o͊֘A.
namespace IO
{
	////////////////////////////////////////////////////////////
	/// IStreambp[.
	/// X}[g|C^̋@\˂.
	class Stream
	{
	private:
		IStream*	m_pStream;
	public:
		////////////////////////////////////////////////////////////
		/// IStreamɑ΂āA͋Stream̍쐬.
		/// @param pStream QƃJEg̓CNg.
		explicit Stream(IStream* pStream = NULL) : m_pStream(pStream)
		{
		}

		////////////////////////////////////////////////////////////
		/// Rs[RXgN^.
		Stream(const Stream& rhs)
		{
			if(m_pStream = rhs.m_pStream)
				m_pStream->AddRef();
		}

		////////////////////////////////////////////////////////////
		/// Zq.
		Stream& operator = (const Stream& rhs)
		{
			if(rhs.m_pStream)
				rhs.m_pStream->AddRef();
			if(m_pStream)
				m_pStream->Release();
			m_pStream = rhs.m_pStream;
			return *this;
		}

		////////////////////////////////////////////////////////////
		/// fXgN^.
		~Stream()
		{
			if(m_pStream)
				m_pStream->Release();
		}

		////////////////////////////////////////////////////////////
		/// IStreamւ̎ϊ.
		operator IStream* ()	{ return m_pStream; }

		////////////////////////////////////////////////////////////
		/// NULL.
		bool	IsNull() const	{ return m_pStream == NULL; }

		////////////////////////////////////////////////////////////
		/// ̃Xg[֌т.
		/// @param pStream QƃJEg̓CNgȂ
		void	Attach(IStream* pStream)
		{
			if(m_pStream)
				m_pStream->Release();
			m_pStream = pStream;
		}

		////////////////////////////////////////////////////////////
		/// Xg[؂藣.
		/// @return QƃJEg̓fNgȂ
		IStream*	Detach()
		{
			IStream* pStream = m_pStream;
			m_pStream = NULL;
			return pStream;
		}

	////////////////////////////////////////////////////////////
	/// @name 쐬Ej
	//@{

		////////////////////////////////////////////////////////////
		/// t@Cɑ΂Stream̍쐬.
		/// @param filename t@C
		/// @param mode 쐬[h
		///
		/// 쐬[hꗗ
		/// - ǂݍ : STGM_STANDARD_READ  = STGM_READ | STGM_SHARE_DENY_WRITE
		/// -  : STGM_STANDARD_WRITE = STGM_WRITE | STGM_SHARE_DENY_WRITE
		/// - Access  : STGM_READ | STGM_WRITE | STGM_READWRITE.
		/// - Sharing : STGM_SHARE_DENY_NONE | STGM_SHARE_DENY_READ | STGM_SHARE_DENY_WRITE | STGM_SHARE_EXCLUSIVE | STGM_PRIORITY
		/// - Creation STGM_CREATE | STGM_CONVERT | STGM_FAILIFTHERE
		/// - Transactioning : STGM_DIRECT | STGM_TRANSACTED
		/// - Transactioning Performance : STGM_NOSCRATCH | STGM_NOSNAPSHOT
		/// - Direct SWMR and Simple : STGM_SIMPLE | STGM_DIRECT_SWMR
		/// - Delete On Release : STGM_DELETEONRELEASE
		HRESULT	CreateOnFile(LPCTSTR filename, DWORD mode);

		////////////////////////////////////////
		/// HGLOBALɑ΂Stream̍쐬.
		/// @param hGlobal ΏۂHGLOBAL
		/// @param deleteOnRelease StreamꂽƂhGlobal邩ۂ
		/// @see GetHGlobal
		HRESULT	CreateOnHGlobal(HGLOBAL hGlobal, BOOL deleteOnRelease);

		////////////////////////////////////////
		/// \[Xɑ΂Stream̍쐬.
		/// Xg[͓ǂݍݐp.
		HRESULT	CreateOnResource(HINSTANCE hInstance, LPCTSTR name, LPCTSTR type);

		////////////////////////////////////////////////////////////
		/// Xg[.
		void	Close()
		{
			if(m_pStream)
			{
				m_pStream->Release();
				m_pStream = NULL;
			}
		}
	//@}

	////////////////////////////////////////////////////////////
	/// @name 
	//@{

		////////////////////////////////////////
		/// Stream̓ǂݍ.
		/// @param buffer obt@
		/// @param size   ǂݍރoCg
		/// @param done   ǂݍ܂ꂽoCg
		HRESULT	Read(void* buffer, UINT32 size, UINT32* done = NULL)
		{
			ASSERT(m_pStream != NULL);
			return m_pStream->Read(buffer, size, (ULONG*)done);
		}

		////////////////////////////////////////
		/// Streamւ̏.
		/// @param buffer obt@
		/// @param size   ރoCg
		/// @param done   ܂ꂽoCg
		HRESULT	Write(const void* buffer, UINT32 size, UINT32* done = NULL)
		{
			ASSERT(m_pStream != NULL);
			return m_pStream->Write(buffer, size, (ULONG*)done);
		}

		////////////////////////////////////////
		/// Stream̃V[N.
		/// @param move   ړoCg
		/// @param method V[N@ (STREAM_SEEK_CUR, STREAM_SEEK_SET, STREAM_SEEK_END)
		/// @param newpos V[Ñ|C^ʒu
		HRESULT	Seek(INT64 move, DWORD method, UINT64* newpos = NULL)
		{
			ASSERT(m_pStream != NULL);
			return m_pStream->Seek((LARGE_INTEGER&)move, method, (ULARGE_INTEGER*)newpos);
		}

		////////////////////////////////////////
		/// f[^TCY̎擾.
		UINT64	GetSize()
		{
			ASSERT(m_pStream != NULL);
			STATSTG stat;
			m_pStream->Stat(&stat, STATFLAG_NONAME);
			return stat.cbSize.QuadPart;
		}

		////////////////////////////////////////
		/// ݂̃|C^ʒu̎擾.
		UINT64	GetPosition()
		{
			UINT64 pos;
			Seek(0, STREAM_SEEK_CUR, &pos);
			return pos;
		}

		////////////////////////////////////////
		/// StreamɊ֘AtꂽHGLOBALnh̎擾.
		/// CreateOnHGlobal()ō쐬ꂽStreamɂ̂ݗL.
		/// @see CreateOnHGlobal
		HGLOBAL	GetHGlobal()
		{
			HGLOBAL hGlobal = NULL;
			::GetHGlobalFromStream(m_pStream, &hGlobal);
			return hGlobal;
		}
	//@}
	};
}	// IO
